package jemu.ui;

/**
 * Title:        JEMU by cpc.devilmarkus.de / jemu.winape.net
 * Description:  JAVA emulator for Amstrad Homecomputers
 * Copyright:    Copyright (c) 2002-2008
 * Company:
 * @author       Devilmarkus
 * @version 4.0
 * 
 * 
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import javax.swing.border.*;
import jemu.system.cpc.CPC;
import java.io.*;
import javax.swing.text.*;

public class Autotype extends WindowAdapter implements WindowListener, ActionListener
{
    protected GridBagConstraints gbcConstraints   = null;
	public static JFrame typeconsole;
        public static String autotext;
	public static JTextArea textArea;
	public JButton button   =new JButton(" Send text "); 
	public JButton button2  =new JButton(" Clear console ");
	public JButton button3  =new JButton(" Copy text ");
	public JButton button4  =new JButton(" Paste text ");
        protected Font font;
        protected Color CPC_BLUE = new Color (00,00,0x7f);
        protected Color CPC_GRAY = new Color (0x7f,0x7f,0x7f);
	public Autotype()
	{
		typeconsole=new JFrame("JavaCPC Autotype");
		Dimension screenSize=Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize=new Dimension((int)(screenSize.width/2),(int)(screenSize.height/2));
		int x=(frameSize.width/2 + 110);
		int y=(frameSize.height/2 + 60);
		typeconsole.setBounds(x,y,340,380);
		textArea=new JTextArea();
                typeconsole.setResizable(false);
		textArea.setLineWrap(true);
		textArea.setEditable(true);
                textArea.setAutoscrolls(true);
                textArea.setBackground(Color.BLACK);
                textArea.setForeground(Color.WHITE);
                textArea.setCaretColor(Color.WHITE);
                textArea.setCaret(new DefaultCaret());

                textArea.setSelectedTextColor(Color.BLACK);
                textArea.setSelectionColor(CPC_GRAY);
                textArea.setBorder(new BevelBorder(BevelBorder.LOWERED));
                InputStream in = getClass().getResourceAsStream("amstrad.ttf");
                try {
                font = Font.createFont(Font.TRUETYPE_FONT, in).deriveFont(Font.PLAIN, 8);
                }
                catch (Exception e) {}
                textArea.setFont(this.font);
                button.setForeground(Color.GREEN);
                button.setBackground(CPC_BLUE);
                button.setFont(this.font);
                button.setBorder(new BevelBorder(BevelBorder.RAISED));
                button.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));                
                button2.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
                button2.setForeground(Color.RED);
                button2.setBackground(CPC_BLUE);
                button2.setFont(this.font);
                button2.setBorder(new BevelBorder(BevelBorder.RAISED));             
                button3.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
                button3.setForeground(Color.YELLOW);
                button3.setBackground(CPC_BLUE);
                button3.setFont(this.font);
                button3.setBorder(new BevelBorder(BevelBorder.RAISED));             
                button4.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
                button4.setForeground(Color.CYAN);
                button4.setBackground(CPC_BLUE);
                button4.setFont(this.font);
                button4.setBorder(new BevelBorder(BevelBorder.RAISED));
		typeconsole.getContentPane().setLayout(new GridBagLayout());
                typeconsole.add(button,getGridBagConstraints(1, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(button2,getGridBagConstraints(2, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(button3,getGridBagConstraints(3, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(button4,getGridBagConstraints(4, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(new JScrollPane(textArea),getGridBagConstraints(1, 1, 1.0, 1.0, 5, GridBagConstraints.BOTH));

                typeconsole.setAlwaysOnTop(true);
		typeconsole.setVisible(false);	
		typeconsole.addWindowListener(this);		
		button.addActionListener(this);	
                button.setFocusable(false);	
		button2.addActionListener(this);	
                button2.setFocusable(false);
		button3.addActionListener(this);	
                button3.setFocusable(false);
		button4.addActionListener(this);	
                button4.setFocusable(false);
	}
			  private GridBagConstraints getGridBagConstraints(int x, int y, double weightx,double weighty,
            int width, int fill)
                {
                if (this.gbcConstraints == null) {
                    this.gbcConstraints = new GridBagConstraints();
                }
                this.gbcConstraints.gridx = x;
                this.gbcConstraints.gridy = y;
                this.gbcConstraints.weightx = weightx;
                this.gbcConstraints.weighty = weighty;
                this.gbcConstraints.gridwidth = width;
                this.gbcConstraints.fill = fill;
            return this.gbcConstraints;
  }
	public synchronized void windowClosing(WindowEvent evt)
	{
		typeconsole.setVisible(false);
		//typeconsole.dispose();
	}
	
	public synchronized void actionPerformed(ActionEvent evt)
	{

                if (evt.getSource() == button) {
                    SendToCPC();
                } 
                if (evt.getSource() == button2)
		textArea.setText("");
                if (evt.getSource() == button3){
                if (!textArea.getText().equals("")){
		textArea.selectAll();
                textArea.copy();
                textArea.paste();}
                }
                if (evt.getSource() == button4)
		textArea.paste();
               
                    //textArea.paste();
	}
        public static void PasteText(){
                typeconsole.setVisible(false);
		textArea.setText("");
                textArea.paste();
		textArea.selectAll();
                autotext = textArea.getText();
                if (CPCPrinter.Processed){
                    autotext = "\n" + autotext;
                CPCPrinter.Processed = false;
                }
                System.out.println("Autotext is:\n"+autotext);
                textArea.select(2000000000, 2000000000);
                CPC.getfromautotype = 1;
        }
        public static void SendToCPC(){
		textArea.selectAll();
                autotext = textArea.getText();
                if (CPCPrinter.Processed){
                    autotext = "\n" + autotext;
                CPCPrinter.Processed = false;
                }
                System.out.println("Autotext is:\n"+autotext);
                CPC.getfromautotype = 1;
                textArea.select(2000000000, 2000000000);
                typeconsole.setVisible(false);
        }
}